#!/usr/bin/perl

use strict;
use utf8;

package Univie::Utheses::API;

use base 'Module';

use LWP;
use JSON -convert_blessed_universally;
use Encode;

=head2 my $utapi= new Univie::Utheses::API( api_url => 'https://utheses-api-utheses-prod.cprod.univie.ac.at/' );

=cut

sub getContainerPublicMetadata
{
  my $self= shift;
  my $utheses_id= shift;

  my ($code1, $res1)= $self->utheses_request('GET', 'container/get/public', $utheses_id);
  print __LINE__, " code1=[$code1] res1=[$res1]\n";

  my $info;
  if ($code1 =~ m#^2#)
  {
    eval
    {
      # utf8::upgrade($res1);
      $info= from_json(decode("utf8", $res1));
    };
    if ($@)
    {
      die $@;
    }
  }

  $info;
}

sub utheses_request
{
  my $self=   shift;
  my $method= shift;
  my $what=   shift;
  my $id=     shift;

  my ($api_url)= map { $self->{config}->{$_} } qw(api_url);

  my $req_url= join ('/', $api_url, $what, $id);
  print __LINE__, " req_url=[$req_url]\n";
  my $req = HTTP::Request->new(
    $method => $req_url,
  );

  my $ua= LWP::UserAgent->new;
  my $res= $ua->request($req);

  # print __LINE__, " res: ", main::Dumper($res);
  my $txt= $res->content();
  return ($res->code(), $txt);
}

1;

